"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createResponseFromObject_1 = require("../createResponseFromObject");
function sequence(mocks) {
    var callCount = 0;
    return function (req, res) {
        if (callCount < mocks.length) {
            var mock = mocks[callCount++];
            return typeof mock === 'function'
                ? mock(req, res)
                : createResponseFromObject_1.createResponseFromObject(mock);
        }
    };
}
exports.sequence = sequence;
